#include <iostream>
#include <string>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <fstream>


#include "adsointerface.h"

#include "unit.h"
#include "text.h"
#include "code.h"
#include "adso.h"
#include "feedback.h"
#include "encoding.h"
#include "memory.h"
#include "polisher.h"
#include "parser.h"
#include "ontology.h"

#define USE_MYSQL 1
//#define USE_COMPILED 1
//#define USE_SQLITE 1



AdsoInterface::AdsoInterface() {

	std::string dbusername = "adso";
	std::string dbpassword = "adso";
	std::string dbdatabase = "expanded";


	// Initialize Variables
	adso = new Adso(dbusername, dbpassword, dbdatabase);
	code = new Code();
	encoding = new Encoding();
	feedback = new Feedback();
	memory = new Memory();
	ontology = new Ontology();
	parser = new Parser();
	polisher = new Polisher();
	text = new Text(adso, code, encoding, feedback, memory, ontology, parser, polisher);

        adso->connect();
        adso->query_string("set names latin1");
        try { adso->connect_verbs(); } catch (...) {}


};
AdsoInterface::~AdsoInterface() {
};


std::string AdsoInterface::translate(std::string x) {

	void *xx;
        text->init_text(x);
        text->pre_unify((Text *) xx);
        text->unify((Text *) xx);
        text->post_unify((Text *) xx);
	text->adjust_confidence((Text *) xx);
        text->run_code((Text *) xx);
        text->combine((Text *) xx);
        text->combine2((Text *) xx);
        text->advanced((Text *) xx);
	return text->return_english();

}
std::string AdsoInterface::segment(std::string x) {

	void *xx;
        text->init_text(x);
        text->pre_unify((Text *) xx);
        text->unify((Text *) xx);
        text->post_unify((Text *) xx);
	text->adjust_confidence((Text *) xx);
        text->run_code((Text *) xx);
        text->combine((Text *) xx);
        text->combine2((Text *) xx);
        text->advanced((Text *) xx);
	return text->return_segmented_chinese();

}
std::string AdsoInterface::pinyinize(std::string x) {

	void *xx;
        text->init_text(x);
        text->pre_unify((Text *) xx);
        text->unify((Text *) xx);
        text->post_unify((Text *) xx);
	text->adjust_confidence((Text *) xx);
        text->run_code((Text *) xx);
        text->combine((Text *) xx);
        text->combine2((Text *) xx);
        text->advanced((Text *) xx);
	return text->return_pinyin();

}






