#ifndef ADSOINTERFACE_H
#define ADSOINTERFACE_H

#include <iostream>
#include <string>
#include <vector>
#include <iterator>

class Adso;
class Code;
class Encoding;
class Feedback;
class Memory;
class Ontology;
class Parser;
class Polisher;
class Text;

class AdsoInterface {


	public:

		// Variables Required for Top-Level Management
		Text *text;
		Adso *adso;
		Encoding *encoding;
		Parser *parser;
		Polisher *polisher;
		Code *code;	
		Feedback *feedback;
		Memory *memory;
		Ontology *ontology;

		AdsoInterface();
		~AdsoInterface();

		std::string translate(std::string x);
		std::string segment(std::string x);
		std::string pinyinize(std::string x);

};

#endif



