#include "phrase.h"
#include "parser.h"
#include "adso.h"
#include "unit.h"
#include "text.h"
#include <vector>
#include <iterator>


Phrase::Phrase(Text *t): Unit(t) { myclass += ":Phrase";};
Phrase::~Phrase() {}

int Phrase::deconstruct_phrases(Text *t, int a, int b, int c) {

 
  // we only delete the current unit we are resegmenting
  int preexisting_phrase_parser_setting = t->parser->no_phrases;
  std::string existing_translation = return_english();


  Text *text4swap1 = new Text(this);

  // covers mysql, sqlite
  text4swap1->adso->no_phrases = 1;
  // covers internal compilation
  text4swap1->parser->no_phrases = 1;

  text4swap1->init_text(return_chinese_input_encoding());


  // revert to original parsing settings
  t->parser->no_phrases = preexisting_phrase_parser_setting;
  t->adso->no_phrases = preexisting_phrase_parser_setting;


  // Filter Our New Elements for Appropriateness
  for (int z = 0; z < text4swap1->elements->at(0)->size(); z++) {
    double highest = 0;
    int    highest_match = 0;
    for (int zz = 0; zz < text4swap1->elements->at(0)->at(z)->size(); zz++) {
      double tempd = text4swap1->elements->at(0)->at(z)->at(zz)->return_translation_similarity_score(existing_translation);
      if (tempd > highest) {
        highest_match = zz;
	highest = tempd;
      }
    }
    text4swap1->make_only(0,z,highest_match);
  }



  // Copy the Non-Phrase Elements into the Main Vector Where Appropriate
  if (text4swap1->elements->size() >= 1) {
    for (int i = 0; i < text4swap1->elements->at(0)->size(); i++) {
      t->elements->at(0)->insert(t->elements->at(0)->begin()+b+i+1, text4swap1->elements->at(0)->at(i));

      // Avoid Memory Management Issues - Replace the Link
      text4swap1->elements->at(0)->at(i) = new std::vector<Text *>;
    }
  }

  // Delete Our Previous Element - (this is the current object)
  t->remove_element(a,b);

  // Deete Temporary Reparsing Text
  delete text4swap1;



}


